﻿using PersonalFinance.Entity;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PersonalFinance
{
    //just for prime testing
    class Program
    {
        public static EntityContext ctx = new EntityContext();
        public static UserService usrsrvc = new UserService(ctx);
        static void Main(string[] args)
        {
            Database.SetInitializer<EntityContext>(new EntityContextInit());


            PrintPayments();
            PrintUsers();
            PrintScheduled();

            PrintInfo("delete user vith ID=5");
            usrsrvc.DeleteUser(5);
            PrintUsers();

            PrintInfo("add two new users");
            User u1 = usrsrvc.AddUser(new User("aarrgh") { Login = "Login1", Name = "Jmeno1", Lastname = "Prijmeni1", Sex = Sex.Male });
            User u2 = usrsrvc.AddUser(new User("aarrgh") { Login = "Login2", Name = "Jmeno2", Lastname = "Prijmeni2", Sex = Sex.Female });
            PrintUsers();

            //PrintInfo("edit new users");
            //u1.Login = "Franta";
            //usrsrvc.UpdateUser(u1);
            //u2.Login = "Františka";
            //usrsrvc.UpdateUser(u2);
            //PrintUsers();


            Console.ReadLine();
        }

        static void PrintInfo(string s) { PrintColorLine("\n>> "+s, ConsoleColor.DarkGray); }
        static void PrintColorLine(string s, ConsoleColor c)
        {
            ConsoleColor ret = Console.ForegroundColor;
            Console.ForegroundColor = c;
            Console.WriteLine(s);
            Console.ForegroundColor = ret;
        }

        public static void PrintUsers()
        {
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("\n===USERS===");
            Console.ForegroundColor = ConsoleColor.White;
            foreach (var user in ctx.Users)
            {
                Console.WriteLine(user);
            }
        }

        public static void PrintScheduled()
        {
            Console.ForegroundColor = ConsoleColor.Magenta;
            Console.WriteLine("\n===SCHEDULED ITEMS===");
            Console.ForegroundColor = ConsoleColor.White;
            foreach (var sched in ctx.ScheduledPayments)
            {
                Console.WriteLine(sched);
            }
        }

        public static void PrintPayments()
        {
            Console.Title = "Výpis databáze";
            Console.ForegroundColor = ConsoleColor.Cyan;
            Console.WriteLine("===PAYMENTS===");
            Console.ForegroundColor = ConsoleColor.White;
            foreach (var payment in ctx.Payments)
            {
                Console.WriteLine(payment);
            }
        }
    }
}
