﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PersonalFinance.Entity
{
    public class BasePayment
    {
        public BasePayment() { }

        public virtual User User { get; set; }

        private int price;
        /// <summary>
        /// Price of payment - must be positive number
        /// </summary>
        public int Price
        {
            get { return price; }
            set
            {
                if (value >= 0) { price = value; }
                else { throw new ArgumentOutOfRangeException("Price cannot be negative."); }
            }
        }

        private PaymentCurrency curr;
        /// <summary>
        /// Payment currency
        /// </summary>
        public PaymentCurrency Currency
        {
            get { return curr; }
            set
            {
                if (PaymentCurrency.IsDefined(typeof(PaymentCurrency), value)) { this.curr = value; }
                else { throw new ArgumentOutOfRangeException("Value is not defined enum from PaymentCurrency!"); }
            }
        }

        /// <summary>
        /// Purpose of payment
        /// </summary>
        public string Purpose { get; set; }

        /// <summary>
        /// Note of payment
        /// </summary>
        public string Note { get; set; }

        private PaymentGroup group;
        /// <summary>
        /// Type of payment (defines the visibility)
        /// </summary>
        public PaymentGroup Group
        {
            get { return group; }
            set
            {
                if (PaymentGroup.IsDefined(typeof(PaymentGroup), value)) { this.group = value; }
                else { throw new ArgumentOutOfRangeException("Value is not defined enum from PaymentGroup!"); }
            }
        }
    }
}
